
#include <Update.h>

#include <WiFiClient.h>
#include <WebServer.h>

#include "pinscan.h"

//#include <LEAmDNS.h>

//#include <LittleFS.h>

// from webupdate.ino

WiFiServer update_server(8080);
WiFiClient update_client;

#define STATE_UPDATE_TIME (1000)
unsigned long state_update_time = 0;

const char* serverIndex = "<form method='POST' action='/update' enctype='multipart/form-data'><input type='file' name='update'><input type='submit' value='Update'></form>";

String setupAPI() {
  return serverIndex;
}

int bytes_read = 0;
int prev_bytes_read = 0;

void setupUpdate() {
  update_server.begin();
  update_server.setNoDelay(true);
}

void updateUpdate() {
  unsigned long ms = millis();

  if (ms - state_update_time > STATE_UPDATE_TIME) {
      state_update_time = ms;

      if (prev_bytes_read != bytes_read) {
        if (stream)
          stream->println("bytes read: " + String(bytes_read));

          prev_bytes_read = bytes_read;
      }
//      Serial.println("curr + " + String(stepper.currentPosition()));
//      Serial.println("target + " + String(stepper.targetPosition()));
  }

  if (update_server.available())
    update_client = update_server.accept();

  if (update_client.connected() == false) {
    update_client.stop();
		update_client = WiFiClient();
  }

  while (update_client.available()) {
    int byte = update_client.read();
    bytes_read++;
  }

}


#if 0
void setupUpdate() {
  update_server.begin();
  update_server.setNoDelay(true);

    server.on(
    "/update", HTTP_POST, []() {
      server.sendHeader("Connection", "close");
      server.send(200, "text/plain", (Update.hasError()) ? "FAIL" : "OK");
      //rp2040.restart();
    },
    []() {
      HTTPUpload& upload = server.upload();
      if (upload.status == UPLOAD_FILE_START) {
        WiFiUDP::stopAll();
        Serial.printf("Update: %s\n", upload.filename.c_str());
        /*
        FSInfo64 i;
        LittleFS.begin();
        LittleFS.format();
        LittleFS.info64(i);

        uint32_t maxSketchSpace = i.totalBytes - i.usedBytes;
        */

        uint32_t maxSketchSpace = 1024;

        if (!Update.begin(maxSketchSpace)) {  // start with max available size
          Update.printError(Serial);
        }
      } else if (upload.status == UPLOAD_FILE_WRITE) {
        if (Update.write(upload.buf, upload.currentSize) != upload.currentSize) {
          Update.printError(Serial);
        }
      } else if (upload.status == UPLOAD_FILE_END) {
        if (Update.end(true)) {  // true to set the size to the current progress
          Serial.printf("Update Success: %u\nRebooting...\n", upload.totalSize);
        } else {
          Update.printError(Serial);
        }
      }
    });

}

#endif
